/// <reference types="node" />
/**
 * @since 0.0.1
 */
import { AsyncIterableX } from 'ix/asynciterable';
import { Monoid } from 'fp-ts/lib/Monoid';
import { Alternative1 } from 'fp-ts/lib/Alternative';
import { Filterable1 } from 'fp-ts/lib/Filterable';
import { Monad1 } from 'fp-ts/lib/Monad';
import { Predicate } from 'fp-ts/lib/function';
import * as E from 'fp-ts/lib/Either';
import * as O from 'fp-ts/lib/Option';
declare module 'fp-ts/lib/HKT' {
    interface URItoKind<A> {
        AsyncIterableX: AsyncIterableX<A>;
    }
}
/**
 * @since 0.0.1
 */
export declare const URI = "AsyncIterableX";
/**
 * @since 0.0.1
 */
export declare type URI = typeof URI;
/**
 * @since 0.0.1
 */
export declare function getMonoid<A = never>(): Monoid<AsyncIterableX<A>>;
/**
 * @since 0.0.1
 */
export declare const asyncIterable: Monad1<URI> & Alternative1<URI> & Filterable1<URI>;
declare const alt: <A>(that: () => AsyncIterableX<A>) => (fa: AsyncIterableX<A>) => AsyncIterableX<A>, ap: <A>(fa: AsyncIterableX<A>) => <B>(fab: AsyncIterableX<(a: A) => B>) => AsyncIterableX<B>, apFirst: <B>(fb: AsyncIterableX<B>) => <A>(fa: AsyncIterableX<A>) => AsyncIterableX<A>, apSecond: <B>(fb: AsyncIterableX<B>) => <A>(fa: AsyncIterableX<A>) => AsyncIterableX<B>, chain: <A, B>(f: (a: A) => AsyncIterableX<B>) => (ma: AsyncIterableX<A>) => AsyncIterableX<B>, chainFirst: <A, B>(f: (a: A) => AsyncIterableX<B>) => (ma: AsyncIterableX<A>) => AsyncIterableX<A>, compact: <A>(fa: AsyncIterableX<O.Option<A>>) => AsyncIterableX<A>, filter: {
    <A, B extends A>(refinement: import("fp-ts/lib/function").Refinement<A, B>): (fa: AsyncIterableX<A>) => AsyncIterableX<B>;
    <A_1>(predicate: Predicate<A_1>): (fa: AsyncIterableX<A_1>) => AsyncIterableX<A_1>;
}, filterMap: <A, B>(f: (a: A) => O.Option<B>) => (fa: AsyncIterableX<A>) => AsyncIterableX<B>, flatten: <A>(mma: AsyncIterableX<AsyncIterableX<A>>) => AsyncIterableX<A>, map: <A, B>(f: (a: A) => B) => (fa: AsyncIterableX<A>) => AsyncIterableX<B>, partition: {
    <A, B extends A>(refinement: import("fp-ts/lib/function").Refinement<A, B>): (fa: AsyncIterableX<A>) => import("fp-ts/lib/Compactable").Separated<AsyncIterableX<A>, AsyncIterableX<B>>;
    <A_1>(predicate: Predicate<A_1>): (fa: AsyncIterableX<A_1>) => import("fp-ts/lib/Compactable").Separated<AsyncIterableX<A_1>, AsyncIterableX<A_1>>;
}, partitionMap: <A, B, C>(f: (a: A) => E.Either<B, C>) => (fa: AsyncIterableX<A>) => import("fp-ts/lib/Compactable").Separated<AsyncIterableX<B>, AsyncIterableX<C>>, separate: <A, B>(fa: AsyncIterableX<E.Either<A, B>>) => import("fp-ts/lib/Compactable").Separated<AsyncIterableX<A>, AsyncIterableX<B>>;
export { 
/**
 * @since 0.0.1
 */
alt, 
/**
 * @since 0.0.1
 */
ap, 
/**
 * @since 0.0.1
 */
apFirst, 
/**
 * @since 0.0.1
 */
apSecond, 
/**
 * @since 0.0.1
 */
chain, 
/**
 * @since 0.0.1
 */
chainFirst, 
/**
 * @since 0.0.1
 */
compact, 
/**
 * @since 0.0.1
 */
filter, 
/**
 * @since 0.0.1
 */
filterMap, 
/**
 * @since 0.0.1
 */
flatten, 
/**
 * @since 0.0.1
 */
map, 
/**
 * @since 0.0.1
 */
partition, 
/**
 * @since 0.0.1
 */
partitionMap, 
/**
 * @since 0.0.1
 */
separate };
/**
 * @since 0.0.1
 */
export declare const fromNodeStream: <E>(stream: NodeJS.ReadableStream, size: number, onreject: (err: unknown) => E) => AsyncIterableX<E.Either<E, string | Buffer>>;
