"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @since 0.0.1
 */
var asynciterable_1 = require("ix/asynciterable");
var operators_1 = require("ix/asynciterable/operators");
var function_1 = require("fp-ts/lib/function");
var pipeable_1 = require("fp-ts/lib/pipeable");
var E = require("fp-ts/lib/Either");
var O = require("fp-ts/lib/Option");
var fromnodestream_1 = require("ix/asynciterable/fromnodestream");
/**
 * @since 0.0.1
 */
exports.URI = 'AsyncIterableX';
/**
 * @since 0.0.1
 */
function getMonoid() {
    return {
        concat: function (x, y) { return asynciterable_1.merge(x, y); },
        empty: asynciterable_1.empty()
    };
}
exports.getMonoid = getMonoid;
/**
 * @since 0.0.1
 */
exports.asyncIterable = {
    URI: exports.URI,
    map: function (fa, f) { return pipeable_1.pipe(fa, operators_1.map(f)); },
    of: function (a) { return asynciterable_1.of(a); },
    ap: function (fab, fa) {
        return pipeable_1.pipe(asynciterable_1.combineLatest(fab, fa), operators_1.map(function (_a) {
            var f = _a[0], a = _a[1];
            return f(a);
        }));
    },
    chain: function (fa, f) { return pipeable_1.pipe(fa, operators_1.flatMap(f)); },
    zero: asynciterable_1.empty,
    alt: function (fx, f) { return asynciterable_1.merge(fx, f()); },
    compact: function (fa) { return exports.asyncIterable.filterMap(fa, function_1.identity); },
    separate: function (fa) { return exports.asyncIterable.partitionMap(fa, function_1.identity); },
    partitionMap: function (fa, f) { return ({
        left: exports.asyncIterable.filterMap(fa, function (a) {
            return pipeable_1.pipe(f(a), E.fold(O.some, function () { return O.none; }));
        }),
        right: exports.asyncIterable.filterMap(fa, function (a) {
            return pipeable_1.pipe(f(a), E.fold(function () { return O.none; }, O.some));
        })
    }); },
    partition: function (fa, p) { return exports.asyncIterable.partitionMap(fa, E.fromPredicate(p, function_1.identity)); },
    filterMap: function (fa, f) {
        return exports.asyncIterable.chain(fa, function (a) {
            return pipeable_1.pipe(f(a), O.fold(function () { return asynciterable_1.empty(); }, exports.asyncIterable.of));
        });
    },
    filter: function (fa, p) { return exports.asyncIterable.filterMap(fa, O.fromPredicate(p)); }
};
var _a = pipeable_1.pipeable(exports.asyncIterable), alt = _a.alt, ap = _a.ap, apFirst = _a.apFirst, apSecond = _a.apSecond, chain = _a.chain, chainFirst = _a.chainFirst, compact = _a.compact, filter = _a.filter, filterMap = _a.filterMap, flatten = _a.flatten, map = _a.map, partition = _a.partition, partitionMap = _a.partitionMap, separate = _a.separate;
exports.alt = alt;
exports.ap = ap;
exports.apFirst = apFirst;
exports.apSecond = apSecond;
exports.chain = chain;
exports.chainFirst = chainFirst;
exports.compact = compact;
exports.filter = filter;
exports.filterMap = filterMap;
exports.flatten = flatten;
exports.map = map;
exports.partition = partition;
exports.partitionMap = partitionMap;
exports.separate = separate;
/**
 * @since 0.0.1
 */
exports.fromNodeStream = function (stream, size, onreject) {
    return pipeable_1.pipe(fromnodestream_1.fromNodeStream(stream, size), operators_1.map(E.right), operators_1.catchError(function (error) { return asynciterable_1.of(E.left(onreject(error))); }));
};
//# sourceMappingURL=AsyncIterableX.js.map