/**
 * @since 0.0.1
 */
import { IterableX } from 'ix/iterable';
import { Monoid } from 'fp-ts/lib/Monoid';
import { Alternative1 } from 'fp-ts/lib/Alternative';
import { Filterable1 } from 'fp-ts/lib/Filterable';
import { Monad1 } from 'fp-ts/lib/Monad';
import { Predicate } from 'fp-ts/lib/function';
import * as E from 'fp-ts/lib/Either';
import * as O from 'fp-ts/lib/Option';
declare module 'fp-ts/lib/HKT' {
    interface URItoKind<A> {
        IterableX: IterableX<A>;
    }
}
/**
 * @since 0.0.1
 */
export declare const URI = "IterableX";
/**
 * @since 0.0.1
 */
export declare type URI = typeof URI;
/**
 * @since 0.0.1
 */
export declare function getMonoid<A = never>(): Monoid<IterableX<A>>;
/**
 * @since 0.0.1
 */
export declare const iterable: Monad1<URI> & Alternative1<URI> & Filterable1<URI>;
declare const alt: <A>(that: () => IterableX<A>) => (fa: IterableX<A>) => IterableX<A>, ap: <A>(fa: IterableX<A>) => <B>(fab: IterableX<(a: A) => B>) => IterableX<B>, apFirst: <B>(fb: IterableX<B>) => <A>(fa: IterableX<A>) => IterableX<A>, apSecond: <B>(fb: IterableX<B>) => <A>(fa: IterableX<A>) => IterableX<B>, chain: <A, B>(f: (a: A) => IterableX<B>) => (ma: IterableX<A>) => IterableX<B>, chainFirst: <A, B>(f: (a: A) => IterableX<B>) => (ma: IterableX<A>) => IterableX<A>, compact: <A>(fa: IterableX<O.Option<A>>) => IterableX<A>, filter: {
    <A, B extends A>(refinement: import("fp-ts/lib/function").Refinement<A, B>): (fa: IterableX<A>) => IterableX<B>;
    <A_1>(predicate: Predicate<A_1>): (fa: IterableX<A_1>) => IterableX<A_1>;
}, filterMap: <A, B>(f: (a: A) => O.Option<B>) => (fa: IterableX<A>) => IterableX<B>, flatten: <A>(mma: IterableX<IterableX<A>>) => IterableX<A>, map: <A, B>(f: (a: A) => B) => (fa: IterableX<A>) => IterableX<B>, partition: {
    <A, B extends A>(refinement: import("fp-ts/lib/function").Refinement<A, B>): (fa: IterableX<A>) => import("fp-ts/lib/Compactable").Separated<IterableX<A>, IterableX<B>>;
    <A_1>(predicate: Predicate<A_1>): (fa: IterableX<A_1>) => import("fp-ts/lib/Compactable").Separated<IterableX<A_1>, IterableX<A_1>>;
}, partitionMap: <A, B, C>(f: (a: A) => E.Either<B, C>) => (fa: IterableX<A>) => import("fp-ts/lib/Compactable").Separated<IterableX<B>, IterableX<C>>, separate: <A, B>(fa: IterableX<E.Either<A, B>>) => import("fp-ts/lib/Compactable").Separated<IterableX<A>, IterableX<B>>;
export { 
/**
 * @since 0.0.1
 */
alt, 
/**
 * @since 0.0.1
 */
ap, 
/**
 * @since 0.0.1
 */
apFirst, 
/**
 * @since 0.0.1
 */
apSecond, 
/**
 * @since 0.0.1
 */
chain, 
/**
 * @since 0.0.1
 */
chainFirst, 
/**
 * @since 0.0.1
 */
compact, 
/**
 * @since 0.0.1
 */
filter, 
/**
 * @since 0.0.1
 */
filterMap, 
/**
 * @since 0.0.1
 */
flatten, 
/**
 * @since 0.0.1
 */
map, 
/**
 * @since 0.0.1
 */
partition, 
/**
 * @since 0.0.1
 */
partitionMap, 
/**
 * @since 0.0.1
 */
separate };
