"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @since 0.0.1
 */
var iterable_1 = require("ix/iterable");
var operators_1 = require("ix/iterable/operators");
var function_1 = require("fp-ts/lib/function");
var pipeable_1 = require("fp-ts/lib/pipeable");
var E = require("fp-ts/lib/Either");
var O = require("fp-ts/lib/Option");
/**
 * @since 0.0.1
 */
exports.URI = 'IterableX';
/**
 * @since 0.0.1
 */
function getMonoid() {
    return {
        concat: function (x, y) { return iterable_1.concat(x, y); },
        empty: iterable_1.empty()
    };
}
exports.getMonoid = getMonoid;
/**
 * @since 0.0.1
 */
exports.iterable = {
    URI: exports.URI,
    map: function (fa, f) { return pipeable_1.pipe(fa, operators_1.map(f)); },
    of: iterable_1.of,
    ap: function (fab, fa) { return exports.iterable.chain(fab, function (f) { return exports.iterable.map(fa, f); }); },
    chain: function (fa, f) { return pipeable_1.pipe(fa, operators_1.flatMap(f)); },
    zero: iterable_1.empty,
    alt: function (fx, f) { return iterable_1.concat(fx, f()); },
    compact: function (fa) { return exports.iterable.filterMap(fa, function_1.identity); },
    separate: function (fa) { return exports.iterable.partitionMap(fa, function_1.identity); },
    partitionMap: function (fa, f) { return ({
        left: exports.iterable.filterMap(fa, function (a) {
            return pipeable_1.pipe(f(a), E.fold(O.some, function () { return O.none; }));
        }),
        right: exports.iterable.filterMap(fa, function (a) {
            return pipeable_1.pipe(f(a), E.fold(function () { return O.none; }, O.some));
        })
    }); },
    partition: function (fa, p) { return exports.iterable.partitionMap(fa, E.fromPredicate(p, function_1.identity)); },
    filterMap: function (fa, f) {
        return exports.iterable.chain(fa, function (a) {
            return pipeable_1.pipe(f(a), O.fold(function () { return iterable_1.empty(); }, exports.iterable.of));
        });
    },
    filter: function (fa, p) { return exports.iterable.filterMap(fa, O.fromPredicate(p)); }
};
var _a = pipeable_1.pipeable(exports.iterable), alt = _a.alt, ap = _a.ap, apFirst = _a.apFirst, apSecond = _a.apSecond, chain = _a.chain, chainFirst = _a.chainFirst, compact = _a.compact, filter = _a.filter, filterMap = _a.filterMap, flatten = _a.flatten, map = _a.map, partition = _a.partition, partitionMap = _a.partitionMap, separate = _a.separate;
exports.alt = alt;
exports.ap = ap;
exports.apFirst = apFirst;
exports.apSecond = apSecond;
exports.chain = chain;
exports.chainFirst = chainFirst;
exports.compact = compact;
exports.filter = filter;
exports.filterMap = filterMap;
exports.flatten = flatten;
exports.map = map;
exports.partition = partition;
exports.partitionMap = partitionMap;
exports.separate = separate;
//# sourceMappingURL=IterableX.js.map